unit uThread;

interface

uses
  Classes,IdFTP, StdCtrls, SysUtils, Dialogs;

type
  TUpload = class(TThread)
  private
   CFTP : TidFTP;
   CEdit : TEdit;
    { Private declarations }
  protected
    procedure Execute; override;
    procedure FazUpload;
   public
   constructor Criar(ftp : Tidftp; edit : tedit);
  end;

implementation


constructor TUpload.Criar(ftp: Tidftp; edit: tedit);
begin
inherited Create(True);
    FreeOnTerminate := True;
    CFTP := ftp;
    CEdit := edit;
    Resume;
end;


procedure TUpload.Execute;
begin
  If (Not Terminated) Then
  FazUpload;
end;

procedure TUpload.FazUpload;
begin
 With CFTP Do
  Begin
   Try
    If not Connected Then
     Connect;
   except
    On E : Exception do
     Begin
      ShowMessage('No conectou : ' + E.Message);
      Exit;
     End;
   end;
   Try
    Try
     Put(CEdit.Text, ExtractFileName(CEdit.Text));
    except
     on E : Exception do
      ShowMessage('Erro ao fazer Upload: ' + E.Message);
    end;
   Finally
    Quit;
   End;
  End;
end;

end.
